=== debian/changelog ===
qhull (2020.1-2) unstable; urgency=medium

  * Team upload.
  * Transition to unstable.

  [ Timo Röhling ]
  * Bump to debhelper compat 13.
  * Debianize test failure message for libqhull_r
  * Disable RPATH completely to make build reproducible
  * Link qhull binaries against shared library

  [ Barak A. Pearlmutter ]
  * update maintainer email
  * use some dh13 facilities

 -- Timo Röhling <timo.roehling@fkie.fraunhofer.de>  Fri, 19 Jun 2020 10:10:14 +0200

qhull (2020.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * New upstream SOVERSION 8.0

 -- Timo Röhling <timo.roehling@fkie.fraunhofer.de>  Sat, 06 Jun 2020 15:58:21 +0200

qhull (2019.1-5) unstable; urgency=medium

  * Team upload.
  * Transition to unstable.

 -- Timo Röhling <timo.roehling@fkie.fraunhofer.de>  Wed, 29 Apr 2020 10:15:52 +0200

qhull (2019.1-4) experimental; urgency=medium

  * Team upload.
  * Import upstream patch for pkg-config support
  * Add autopkgtest compile and link test
  * Fix issues with local documentation

 -- Timo Röhling <timo.roehling@fkie.fraunhofer.de>  Mon, 20 Apr 2020 16:11:23 +0200

qhull (2019.1-3) experimental; urgency=medium

  * Team upload.
  * Fix arch-indep build
  * Disable RPATH at build time

 -- Timo Röhling <timo.roehling@fkie.fraunhofer.de>  Fri, 10 Apr 2020 19:03:03 +0200

qhull (2019.1-2) experimental; urgency=medium

  * Team upload.
  * Use correct CMake build path for tests
  * Mark exported C++ STL symbols as optional
  * Build with LFS support

 -- Timo Röhling <timo.roehling@fkie.fraunhofer.de>  Fri, 10 Apr 2020 13:50:23 +0200

qhull (2019.1-1) experimental; urgency=medium

  [ Barak A. Pearlmutter ]
  * Strip unusual field spacing from debian/control.
  * Bump debhelper from old 11 to 12.
  * New upstream version
  * Track minor upstream fix commits
  * Bump standards version
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Timo Röhling ]
  * Turn post-release upstream fixes into proper patches
  * Ship qhullcpp as shared library (Closes: #925540)
  * Add R-R-R to debian/control
  * Fix unit tests and honor DEB_BUILD_OPTIONS
  * Fix reproducibility issue with assert() macros
  * Install all documentation to the recommended place
  * Fix privacy breach
  * Bump SONAME because of ABI breakage
  * Make copyright DEP5 conforming
  * Add .symbols files for all shared libraries
  * Properly export CMake targets

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 07 Apr 2020 23:02:09 +0100

qhull (2015.2-4) unstable; urgency=medium

  * Team upload.
  * Add missing Depends: libqhull-r7 (Closes: #883817)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 09 Dec 2017 19:18:30 +0100

qhull (2015.2-3) unstable; urgency=medium

  * bump policy version
  * Add libqhull-r7 package (closes: #841168)
    thanks to Jochen Sprickerhof <jspricke@debian.org>

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 25 Nov 2017 23:44:11 +0000

qhull (2015.2-2) unstable; urgency=medium

  * bump to debhelper 10
  * bump policy version
  * spelling error quilt patch
  * harden

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 18 Jan 2017 13:33:24 +0000
