=== debian/tests/control ===
Tests: build
Depends: libqhull-dev, cmake, pkg-config, gcc | c-compiler, g++ | c++-compiler
